# -----------------------------------------------------------------------------
# $Id: Pong.pm,v 1.7 2004/02/23 02:46:20 topia Exp $
# -----------------------------------------------------------------------------
# $Clovery: tiarra/module/System/Pong.pm,v 1.2 2003/02/09 02:23:58 topia Exp $
package System::Pong;
use strict;
use warnings;
use NumericReply;
use base qw(Module);

sub message_arrived {
    my ($this,$message,$sender) = @_;
    
    if ($message->command eq 'PING') {
	my ($prefix) = do {
	    if ($sender->isa('IrcIO::Server')) {
		undef;
	    } else {
		RunLoop->shared_loop->sysmsg_prefix(qw(system));
	    }
	};
	my ($nick) = do {
	    if ($sender->isa('IrcIO::Server')) {
		$sender->current_nick;
	    } else {
		RunLoop->shared_loop->current_nick;
	    }
	};
	if ($message->n_params < 1) {
	    # ĤƤС/饤Ȥ˥顼֤
	    $sender->send_message(
		new IRCMessage(
		    Prefix => $prefix,
		    Command => ERR_NOORIGIN,
		    Params => [
			$nick,
			'No origin specified',
		       ]));
	} else {
	    my ($target);
	    if ($sender->isa('IrcIO::Server')) {
		$nick = undef;
		$target = $sender->server_hostname;
	    } else {
		$target = RunLoop->shared_loop->sysmsg_prefix(qw(system));
	    }
	    # ĤƤС/饤ȤPONG֤
	    $sender->send_message(
		new IRCMessage(
		    Prefix => $prefix,
		    Command => 'PONG',
		    Params => [
			$target,
			(defined $nick ? $nick : ()),
		       ]));
	}
	# print "System::Pong ponged to ".$message->params->[0].".\n";
	
	# PINGåϤʾãǾäƤޤ
	return undef;
    }
    elsif ($message->command eq 'PONG') {
	# PONGåϤʾãǾäƤޤ
	return undef;
    }
    else {
	return $message;
    }
}

1;

=pod
info: СPINGåФưŪPONG֤
default: on

# offˤȥ饤ȤPING˱ʤʤޤ
# 饤ȤPONGåϥǥեȤΥСΤ
# ǥեȰʳΥСPing TimeoutȤʤ
# ɤޤ
#   ܤϤޤ
=cut
