# -----------------------------------------------------------------------------
# $Id: Raw.pm,v 1.5 2004/06/04 12:57:30 topia Exp $
# -----------------------------------------------------------------------------
package System::Raw;
use strict;
use warnings;
use base qw(Module);
use Mask;
use NumericReply;

sub message_arrived {
    my ($this, $msg, $sender) = @_;
    if ($sender->client_p and
	  $msg->command eq uc($this->config->command || 'raw')) {
	# ¥ѥ᥿ɬס
	if ($msg->n_params < 2) {
	    $sender->send_message(
		IRCMessage->new(
		    Prefix => RunLoop->shared_loop->sysmsg_prefix(qw(system)),
		    Command => ERR_NEEDMOREPARAMS,
		    Params => [
			RunLoop->shared->current_nick,
			"command `".$msg->command."' requires 2 or more parameters",
		       ]));
	}
	else {
	    # λΤ롣ϥޥ
	    my $target = $msg->param(0);
	    
	    # åƹ
	    my $raw_msg = IRCMessage->new(
		Line => join(' ', @{$msg->params}[1 .. ($msg->n_params - 1)]),
		Encoding => 'utf8',
	       );

	    # ޥ˥ޥåͥåȥƤˤ롣
	    my $sent;
	    foreach my $network (RunLoop->shared->networks_list) {
		if (Mask::match($target, $network->network_name)) {
		    $network->send_message($raw_msg);
		    $sent = 1;
		}
	    }
	    if (!$sent) {
		$sender->send_message(
		    IRCMessage->new(
			Prefix => RunLoop->shared_loop->sysmsg_prefix(qw(priv system)),
			Command => 'NOTICE',
			Params => [
			   RunLoop->shared->current_nick, 
			   "*** no networks matches to `$target'",
			  ]));
	    }
	}
	$msg = undef; # ˴
    }
    $msg;
}

1;
=pod
info: ޥǻꤷСIRCåùľ롣
default: off

# 㤨QUITǰŪǤǽ

# εǽѤ뤿Υޥ̾ǥեȤϡrawס
# /raw ircnet quitפΤ褦ˤƻȤ
# ܤΥѥ᡼Υͥåȥ̾磻ɥɻѲǽ
# CHOCOA ξ硢 raw 饤ȤǻȤƤޤΤǡ
# ޥ̾Ѥ뤫 /raw raw ircnet quit Τ褦ˤɬפ롣
command: raw
=cut
